program sumup(OUTPUT);

{***************************************************************************}
{*                                                                         *}
{*     Testroutine der Pascal-XSC Bib. in Kombination mit AWA              *}
{*                                                                         *}
{*     Programm von :     Boris Hoeffgen                                   *}
{*                        (C) 2000-2004 Wiss. Rechnen/Softwaretechnologie  *}
{*                            Universitaet Wuppertal, Germany              *}
{*                                                                         *}
{***************************************************************************}

type countArr = array[1..4] of integer;
type dummyArr = array[1..4] of integer;

var counter : countArr;
    dummy   : dummyArr;
    RESULT  : text;

begin
	counter[1] := 0;
	counter[2] := 0;
	counter[3] := 0;
	counter[4] := 0;
	writeln;
	writeln('***********************************************************');
	writeln('*                    AWA - FINAL RESULT                   *');
	writeln('***********************************************************');
	writeln;
	reset(RESULT,'ergebnis.dat');
	while not eof(RESULT) do
	begin
		readln(RESULT,dummy[1],dummy[2],dummy[3],dummy[4]);
		counter[1] := counter[1] + dummy[1];
		counter[2] := counter[2] + dummy[2];
		counter[3] := counter[3] + dummy[3];
		counter[4] := counter[4] + dummy[4];
	end;
	writeln;
        writeln('Number of equalities : ',counter[1]);
  	writeln('Number of subsets    : ',counter[2]);
        writeln('Number of supersets  : ',counter[3]);
  	writeln('Other relations      : ',counter[4]);
	if counter[1] = 4536 then
	begin
		writeln;
    		writeln('*************************************************************');
    		writeln('*    All results are equal to the expected solutions.       *');
    		writeln('* It seems the libraries (Pascal-XSC) are OK!               *');
    		writeln('*************************************************************');
	end
  	else 
	begin
		if (counter[1]+counter[3]) = 6088 then
		begin
			writeln;
    			writeln('**************************************************************');
    			writeln('*    All results are equal to or supersets of the            *');
    			writeln('*                  expected solutions.                       *');
    			writeln('*  It seems the libraries (Pascal-XSC) are OK!               *');
    			writeln('**************************************************************');
		end
  		else
		begin
			writeln;
     			writeln('*************************************************************');
     			writeln('*     Warning: There are some unexpected solutions!         *');
     			writeln('* It seems the library (Pascal-XSC) im kombination with AWA *');
			writeln('* is not OK!                                                *');
     			writeln('*************************************************************');
		end;
	end;
end.
