/*
 *   FILE : extras.h
 *   contains special definitions of the PASCAL-XSC to C compiler
 *
 *  Author: Boris Hoeffgen <hoeffgen@uni-wuppertal.de>
 *  creation date:  07.12.05  15:02
*/

#ifndef EXTRA_H
#define EXTRA_H 1

boolean
  os_verbose = false 	 ,  on_verbose = false 	  ,	/* verbose compiler     */
  os_list    = false 	 ,  on_list    = false	  ,	/* listing to file      */
  os_warning = false 	 ,  on_warning = false 	  ,	/* report warnings      */
  os_merge   = false 	 ,  on_merge   = false	  ,	/* merge source in code */
  os_code    = false 	 ,  on_code    = false 	  ,  	/* code generation      */
  os_rename  = false 	 ,  on_rename  = true 	  ,  	/* rename Pascal idents */
  os_index   = false 	 ,  on_index   = true 	  ,  	/* index check          */
  os_number  = false 	 ,  on_number  = true 	  ,  	/* linenumbers in code  */
  os_include = false 	 ,  on_include = false    ,  	/* include "filename"   */
  os_dump    = false 	 ,  on_dump    = false    ,  	/* structab dump        */
  os_terminal= false 	 ,  on_terminal= false	  ,  	/* code to terminal     */
  os_handling= false 	 ,  on_handling= false    ,  	/* explain error hanndling */
  os_fastfor = false     ,  on_fastfor = false 	  ,  	/* for-loops for vector processors */
  os_bib     = false     ,  on_bib     = false	  ,  	/* flags for library modules */
  os_print_check = false , on_print_check = false , 	/* print check messages */
  on_srcdir  = false	 ,		     		/* output directory     */
  on_remove  = true	 ,		     		/* remove output files  */
  on_prototyp= true	 ,		     		/* new style prototypes */
  on_reverse = true	 ,		     		/* link modules in reverse */
  os_dummy;

#endif
