{    ********************************************************************
     *        This program splits a module into individuel procedures;  *
     * and finds out local procedures, changes it to external procedures*
     * and renames them  in backward order ( ZZ, ZY, ZX.....)           *
     * One can   change some constant values in front of the program    *
     * before using this program:                                       *
     *                                                                  *
     *     All the procedures are generated under the current directory *
     *     firstline  := '#include "*.i'; z.B. *= ci_ari.i              *
     *
     *   on March 5 , make two correctoins , because the change of the  *
     * form of the generated c-code.                                    *
     ********************************************************************}


{                                  main
				     |
	      -----------------------------------------------
	      |              |                 |             |
	   inline       includeline        procname      writeifile
					       |
					   cmpstatic
									     }
program splitmod{(input,output,infile,outfile)} ;
label 10 ;
const                                 {1990 11 30 : ok }
     maxcol  = 100 ;
     blank   = ' ';
     imax    = 500;   {the supposed lines of file: *.i }
type
     colindex = 1 .. maxcol;
     line     =  array [colindex] of char;

var
     column       : colindex;
     c            : char;
     find, findbrace , findpre, march5  : boolean;
     buffer, blankline , firstline      : line;
     ifile                              : array [ 1.. imax] of line;
     lineno, col, j, i, ptrii,flno,l,len: integer;
     ifilecnt , staticno                : integer;
     infile, outfile , name             : text;
     fname, fn, incldname               : array [1..20] of char;
     localcnt                           : array [1..2] of char;

procedure cmpstatic;
		       {compare the first six char in a line with 'static'}
		       {and change 'static' into 'extern'. }
var
     jj : integer;
begin
     if (( buffer[1] = 's' ) and  ( buffer[2] = 't' ) and
	 ( buffer[3] = 'a' ) and  ( buffer[4] = 't' ) and
	 ( buffer[5] = 'i' ) and  ( buffer[6] = 'c' ))then
     begin
	 buffer[1] := 'e' ;
	 buffer[2] := 'x' ;
	 buffer[3] := 't' ;
	 buffer[4] := 'e' ;
	 buffer[5] := 'r' ;
	 buffer[6] := 'n' ;
   {      writeln(' ,  Static was changed  to extern :');
	 writeln;     }
    end;
end;   {end of cmpstatic }


procedure inline(var head : text);
var
	 jj : integer ;
begin
	 i := 1 ;
	 buffer := blankline ;
	 if not (( findbrace = true ) and ( find = false )) then
	 begin
	     while not eoln(infile) do
	     begin
		 read(infile, buffer[i]);
		 write(head, buffer[i]);
		 i := 1 + i ;
	     end;
	     readln(infile);
	     writeln(head);
	 end
	 else           { write into array file.i }
	 begin
	     while not eoln(infile) do
	     begin
		 read(infile, buffer[i]);
		 ifile[ifilecnt,i] := buffer[i ];
		 i := 1 + i ;
	     end;
	     readln(infile);
	     ifilecnt := ifilecnt + 1 ;
	 end;
end;    { end of inlint }

procedure includeline ;
		  { generate the firstline #include of the procedure }
var
    count : integer;
begin
    firstline  := '#include "'; { ci_ari.i" }
    count := 11 ;

    for  l :=  count to count + len - 1 do      {_ari.c}
    begin
	firstline[ l ] := fn[ l - count + 1 ] ;
	incldname[ l + 1 - count ] := fn[ l - count + 1 ] ;
    end;
    for  l :=  count + len  to maxcol  do
	firstline[ l ] := blank ;
    firstline[count + len -1] := 'i'   ;
    incldname[len] := 'i'   ;
    incldname[len+1]:= chr(0)  ;
    firstline[count + len ] := '"'  ;
end;    { of includeline }

procedure procname;
var
    proclen , minl : integer;
begin
     find := false;
     for  l :=  1  to 10  do
	  fname[ l ]  := chr(0) ;

     proclen := len;
     if ( len > 8 ) then
	 proclen := 8;

		{ search procedure name :}
     while (not find) and (col < ptrii ) and  (buffer[ 1 ] <> ' ' ) do
     begin
	   find := true ;
	   find := ( buffer[ col ] = fn[1] ) and find;
	   if find then
	       for i := 2 to ( proclen - 2 ) do
		   find := ( buffer[ col+2+(i-1) ] = fn[i] ) and find ;
	   if find then
	   begin
{writeln('...........find',lineno : 8);
}               j := 0 ;
	       for i := col to col + proclen - 1 do
	       begin
		   j := j + 1 ;
		   fname[j] := buffer[i]
	       end;
	       fname[ j + 1 ]  := '.';
	       fname[ j + 2 ] := 'c';
	       find := true ;
	   end ;
			    { 2 . find local names of proc func operator ,}
			    {     such as :      pr_000, fu_002, op_000}
	   if ( not find ) then
		   if((buffer[col] = 'p') and (buffer[col+1]='r') or
		      (buffer[col] = 'f') and (buffer[col+1]='u') or
		      (buffer[col] = 'o') and (buffer[col+1]='p') ) and
		      (buffer[col+2]='_') and
		      (buffer[col+6]=' ') and (buffer[col+7]='(') then
		   begin
		       if (buffer[col+3] in ['0' .. '9']) and
			  (buffer[col+4] in ['0' .. '9']) and
			  (buffer[col+5] in ['0' .. '9']) then
			begin
			    staticno := staticno + 1 ;
{writeln;
write('***********find',lineno : 8,'  ');
}                            j := 0 ;
			    {minl := min(len-2,6);}
			    minl := len-2;
			    if 6 < len - 2 then
				minl := 6 ;
			    for i := 1 to minl  do
				fname[i + 2] := fn[i];
			    fname[ 1 ]       := fn[1];
			    fname[ 2 ]       := localcnt[1];
			    fname[ 3 ]       := localcnt[2];
			    fname[ minl + 3 ] := '.';
			    fname[ minl + 4 ] := 'c';
			    find := true ;
			    {rename the local procedures:}
			    if   localcnt[2] = '0' then
			    begin
			       localcnt[1] := chr(ord(localcnt[1])-1);
			       localcnt[2] := 'Z';
			    end
			    else if localcnt[2] = 'A' then
				 localcnt[2] := chr(ord(localcnt[2])-8)
				 else
				 localcnt[2] := chr(ord(localcnt[2])-1)
			end;
		   end;
	 findpre := find  ;
	 find := find and ( buffer[ptrii-1] <> ';' ) ;
	 if  (find = true) then
	 begin
	     findbrace := false ;
	     cmpstatic;      {if the func or proc is 'static', change
			      it to 'extern' }
{for i := 1 to 10 do
write(fname[i]);
writeln(' lineno=', lineno);
}                             {generate all the files under current dir}
		 rewrite(outfile,fname);
		 writeln(outfile, firstline );
		 writeln(outfile);
		 writeln(outfile);
	end;
	col := col+1;
     end; { end of while }
end; {end of procname }

procedure writeifile;
    {  write array ifile into file: *.i ,  1990 11 29..Thur.}
begin
	   { open include file :  }
    rewrite(outfile,incldname );

    for i := 1 to ifilecnt - 1 do
    begin
	for j := 1 to maxcol do
	    write(outfile , ifile[ i , j ] ) ;
	writeln(outfile ) ;
    end;
end; {  end of writeifile    }

begin  {main}
     staticno  := 0 ;
     ifilecnt  := 1 ;
     findbrace := false ;
     buffer[1] := '#';
     localcnt[1] := 'Z';
     localcnt[2] := 'Z';
     lineno      := 0 ;
     for column := 1 to maxcol do
	 blankline[column] := blank;
     firstline := blankline;
     for i := 1 to imax do
	 ifile[ i ] := blankline;
     for column := 1 to 10 do
	 fname[column] := blank;
     find := false;

     writeln;
   {  write('        Please input module name :');  }

  {  i := 1 ;                        1990 11 12 change
     read( c ) ;  read the 'eoln' after $splitmod.exe
     while not(eoln) do
     begin
	 read(fn[i]) ;
	 i := i + 1 ;
     end;   }

     i := 1 ;
     reset (name ,'name');
     while not( eoln(name) or eof(name) ) do
     begin
	 read(name,fn[i]) ;
	 i := i + 1 ;
     end;
     fn[i] := '.';
     fn[i+1] := 'c';
     len := i + 1 ; {len -- the length of the module name. z.B. c_ari.c: 7}

     includeline ;     { generate the 'firstline'--include  } {Oct.31}


     reset (infile,fn  );

     { process #include, extern,.. in the front and generate *.i file}

     while not ( find ) and not eof( infile ) do
     begin
	      ptrii  := 1 ;
	      buffer := blankline ;
	      while not eoln(infile) do
	      begin
		  read(infile, buffer[ptrii]);
		  ptrii := 1 + ptrii ;
	      end;
	      readln(infile);
	      lineno := lineno + 1;
	      col := 1;
	      procname;
	      i := 1 ;
	      while i < ptrii do
	      begin
		   if not find then
		       ifile[ifilecnt , i] := buffer[i]
		   else
		       write(outfile, buffer[i]);
		   i := 1 + i ;
	      end;
	      if  find then
		  writeln(outfile )
	      else
		  ifilecnt := ifilecnt + 1 ;
	     flno := lineno;
     end {while };

     while not eof(infile  ) do     {split the module:}
     begin
	  lineno := lineno + 1;
	  inline(outfile);
		      { 1991 Mar 5: original version is that the first
			char ([1]) is  the end of the proc. }
	  if buffer[3] = '}'  then
	  begin
	       findbrace := true ;
	       find      := false;
	  end;
	       march5    := false ;
{march5:}
	  if i>10 then
	  if (buffer[1]  <> ' ') and
	     (buffer[i-3] = '(') and
	     (buffer[i-2] = ')') and
	     (buffer[i-1] = ';') then
	  begin
	       march5    := true ;
	       find      := false;
	  end;
		      {find blankline, since there is always  a
		       blankline before the first line of a procedure.}
		      { 1991 Mar 5: or a line with only the third char
			is the end of the proc.
			or extern ......    ();  }
	  if {buffer = blankline}( i = 1) or
	      ( march5     = true )       or
	     ( (findbrace = true ) and not eof(infile) ) then
	  begin
10:           ptrii := 1 ;
	      buffer := blankline ;
	      while not eoln(infile) do
	      begin
		  read(infile, buffer[ptrii]);
		  ptrii := 1 + ptrii ;
	      end;
	      readln(infile);
	      lineno := lineno + 1;
	      col := 1;
{writeln('....before procname',lineno : 8);
}              procname;
			  {two continuous blankline: }
	      if ptrii = 1 then     goto 10 ;
	      i := 1 ;
	      if not( (findbrace = true) and (find = false){ or
		      (find = false) and (findpre = true)} ) then
	      begin
		  while i < ptrii do
		  begin
		      write(outfile, buffer[i]);
		      i := 1 + i ;
		  end;
		  writeln(outfile);
	      end
	      else   { write into file.i : }
	      begin
		  while i < ptrii do
		  begin
		       ifile[ifilecnt,i] := buffer[i];
		       i := 1 + i ;
		  end;
		  ifilecnt := ifilecnt + 1 ;
	      end;
{march5:}
	  if (march5 = true) and (not find ) then
	      if ( i>10 ) and (buffer[1] <> ' ')then
	      if (buffer[i-3] = '(') and
		 (buffer[i-2] = ')') and
		 (buffer[1]  <> ' ') and
		 (buffer[i-1] = ';') then
	      begin
		   march5    := true ;
		   find      := false;
		   goto 10
	      end
	      else
		   march5    := false ;

	 end ;   {end of if }
    end ;        {end of while }

    writeifile;
    writeln;
  {  writeln('There are altogether ', staticno, ' local programs.');
   } writeln
end .
