/**********************************************************************/
/*                                                                    */
/*   "DP_GEN_1.H"                                                     */
/*                                                                    */
/*   Last change    == Feb-14-91 ==                                   */
/*        A.Just / R.Hammer                                           */
/*                                                                    */
/* This module contains functions to generate the bintree, containing */
/* the execution of a dot expression (Part 1).                        */
/*                                                                    */
/**********************************************************************/



#define ACCU1  (d_varcopy(accu1))
#define ACCU2  (d_varcopy(accu2))
#define ACCU3  (d_varcopy(accu3))
#define ACCU4  (d_varcopy(accu4))



/**************************************************************************/



#ifdef LINT_ARGS

     global binptr  d_gexpr      ( tNODE* );
     global binptr  d_gloop      ( binptr, binptr, binptr, binptr*, symctype );
     global binptr  d_varcopy    ( binptr );
     global void    d_undecl     ( binptr );
#ifdef IBMva
     global binptr  d_gfp        ();
#else
     global binptr  d_gfp        ( char*, int, ... );
#endif

#else

     global binptr  d_gexpr      ();
     global binptr  d_gloop      ();
     global binptr  d_varcopy    ();
     global void    d_undecl     ();
     global binptr  d_gfp        ();

#endif



/**************************************************************************/




/*----------------------------------*/
/* module relative global variables */
/*----------------------------------*/

global binptr       accu1,accu2,accu3,accu4; /* dot accus             */
global binptr       row_var,col_var;    /* count vars for main loop   */
global tARITHTYPE   base_res;           /* basetype of dot expression */
global tSTRUCTYPE   struc_res;          /* structure of dot expr.     */
global boolean      plus_mode;          /* TRUE when addition         */



/**************************************************************************/
